Index: trunk/client/modules/Elezioni/grafici/jpgraph_radar.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph_radar.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph_radar.php	(revision 265)
@@ -508,229 +555,304 @@
     public $grid,$axis=null;
     private $posx,$posy;
-    private $len;		
+    private $len;
     private $axis_title=null;
-//---------------
-// CONSTRUCTOR
-    function RadarGraph($width=300,$height=200,$cachedName="",$timeout=0,$inline=1) {
-	$this->Graph($width,$height,$cachedName,$timeout,$inline);
-	$this->posx=$width/2;
-	$this->posy=$height/2;
-	$this->len=min($width,$height)*0.35;
-	$this->SetColor(array(255,255,255));
-	$this->SetTickDensity(TICKD_NORMAL);
-	$this->SetScale("lin");
-	$this->SetGridDepth(DEPTH_FRONT);
-
-    }
-
-//---------------
-// PUBLIC METHODS
-    function SupressTickMarks($f=true) {
-    	if( ERR_DEPRECATED )
-	    JpGraphError::RaiseL(18002);
-//('RadarGraph::SupressTickMarks() is deprecated. Use HideTickMarks() instead.');
-	$this->axis->scale->ticks->SupressTickMarks($f);
+
+    function __construct($width=300,$height=200,$cachedName="",$timeout=0,$inline=1) {
+        parent::__construct($width,$height,$cachedName,$timeout,$inline);
+        $this->posx = $width/2;
+        $this->posy = $height/2;
+        $this->len = min($width,$height)*0.35;
+        $this->SetColor(array(255,255,255));
+        $this->SetTickDensity(TICKD_NORMAL);
+        $this->SetScale('lin');
+        $this->SetGridDepth(DEPTH_FRONT);
     }
 
     function HideTickMarks($aFlag=true) {
-		$this->axis->scale->ticks->SupressTickMarks($aFlag);
-    }
-    
+        $this->axis->scale->ticks->SupressTickMarks($aFlag);
+    }
+
     function ShowMinorTickmarks($aFlag=true) {
-    	$this->yscale->ticks->SupressMinorTickMarks(!$aFlag);
-    }
-	
+        $this->yscale->ticks->SupressMinorTickMarks(!$aFlag);
+    }
+
     function SetScale($axtype,$ymin=1,$ymax=1,$dummy1=null,$dumy2=null) {
-	if( $axtype != "lin" && $axtype != "log" ) {
-	    JpGraphError::RaiseL(18003,$axtype);
-//("Illegal scale for radarplot ($axtype). Must be \"lin\" or \"log\"");
-	}
-	if( $axtype=="lin" ) {
-	    $this->yscale = new LinearScale($ymin,$ymax);
-	    $this->yscale->ticks = new RadarLinearTicks();
-	    $this->yscale->ticks->SupressMinorTickMarks();
-	}
-	elseif( $axtype=="log" ) {
-	    $this->yscale = new LogScale($ymin,$ymax);
-	    $this->yscale->ticks = new RadarLogTicks();
-	}
-		
-	$this->axis = new RadarAxis($this->img,$this->yscale);
-	$this->grid = new RadarGrid();		
+        if( $axtype != 'lin' && $axtype != 'log' ) {
+            JpGraphError::RaiseL(18003,$axtype);
+            //("Illegal scale for radarplot ($axtype). Must be \"lin\" or \"log\"");
+        }
+        if( $axtype == 'lin' ) {
+            $this->yscale = new LinearScale($ymin,$ymax);
+            $this->yscale->ticks = new RadarLinearTicks();
+            $this->yscale->ticks->SupressMinorTickMarks();
+        }
+        elseif( $axtype == 'log' ) {
+            $this->yscale = new LogScale($ymin,$ymax);
+            $this->yscale->ticks = new RadarLogTicks();
+        }
+
+        $this->axis = new RadarAxis($this->img,$this->yscale);
+        $this->grid = new RadarGrid();
     }
 
     function SetSize($aSize) {
-	if( $aSize < 0.1 || $aSize>1 )
-	    JpGraphError::RaiseL(18004,$aSize);
-//("Radar Plot size must be between 0.1 and 1. (Your value=$s)");
-	$this->len=min($this->img->width,$this->img->height)*$aSize/2;
+        if( $aSize < 0.1 || $aSize>1 ) {
+            JpGraphError::RaiseL(18004,$aSize);
+            //("Radar Plot size must be between 0.1 and 1. (Your value=$s)");
+        }
+        $this->len=min($this->img->width,$this->img->height)*$aSize/2;
     }
 
     function SetPlotSize($aSize) {
-	$this->SetSize($aSize);
+        $this->SetSize($aSize);
     }
 
     function SetTickDensity($densy=TICKD_NORMAL,$dummy1=null) {
-	$this->ytick_factor=25;		
-	switch( $densy ) {
-	    case TICKD_DENSE:
-		$this->ytick_factor=12;			
-	    break;
-	    case TICKD_NORMAL:
-		$this->ytick_factor=25;			
-	    break;
-	    case TICKD_SPARSE:
-		$this->ytick_factor=40;			
-	    break;
-	    case TICKD_VERYSPARSE:
-		$this->ytick_factor=70;			
-	    break;		
-	    default:
-		JpGraphError::RaiseL(18005,$densy);
-//("RadarPlot Unsupported Tick density: $densy");
-	}
+        $this->ytick_factor=25;
+        switch( $densy ) {
+            case TICKD_DENSE:
+                $this->ytick_factor=12;
+                break;
+            case TICKD_NORMAL:
+                $this->ytick_factor=25;
+                break;
+            case TICKD_SPARSE:
+                $this->ytick_factor=40;
+                break;
+            case TICKD_VERYSPARSE:
+                $this->ytick_factor=70;
+                break;
+            default:
+                JpGraphError::RaiseL(18005,$densy);
+                //("RadarPlot Unsupported Tick density: $densy");
+        }
     }
 
     function SetPos($px,$py=0.5) {
-	$this->SetCenter($px,$py);
+        $this->SetCenter($px,$py);
     }
 
     function SetCenter($px,$py=0.5) {
-	assert($px > 0 && $py > 0 );
-	$this->posx=$this->img->width*$px;
-	$this->posy=$this->img->height*$py;
-    }
-
-    function SetColor($c) {
-	$this->SetMarginColor($c);
-    }
-			
-    function SetTitles($title) {
-	$this->axis_title = $title;
-    }
-
-    function Add($splot) {
-	$this->plots[]=$splot;
-    }
-	
+        if( $px >= 0 && $px <= 1 ) {
+        	$this->posx = $this->img->width*$px;
+        }
+        else {
+        	$this->posx = $px;
+        }
+        if( $py >= 0 && $py <= 1 ) {
+        	$this->posy = $this->img->height*$py;
+        }
+        else {
+        	$this->posy = $py;
+        }
+    }
+
+    function SetColor($aColor) {
+        $this->SetMarginColor($aColor);
+    }
+
+    function SetTitles($aTitleArray) {
+        $this->axis_title = $aTitleArray;
+    }
+
+    function Add($aPlot) {
+    	if( $aPlot == null ) {
+            JpGraphError::RaiseL(25010);//("Graph::Add() You tried to add a null plot to the graph.");
+        }
+        if( is_array($aPlot) && count($aPlot) > 0 ) {
+            $cl = $aPlot[0];
+        }
+        else {
+            $cl = $aPlot;
+        }
+
+        if( $cl instanceof Text ) $this->AddText($aPlot);
+        elseif( class_exists('IconPlot',false) && ($cl instanceof IconPlot) ) $this->AddIcon($aPlot);
+        else {
+            $this->plots[] = $aPlot;
+        }
+    }
+
     function GetPlotsYMinMax($aPlots) {
-	$min=$aPlots[0]->Min();
-	$max=$aPlots[0]->Max();
-	foreach( $this->plots as $p ) {
-	    $max=max($max,$p->Max());
-	    $min=min($min,$p->Min());
-	}
-	if( $min < 0 ) 
-	    JpGraphError::RaiseL(18006,$min);
-//("Minimum data $min (Radar plots should only be used when all data points > 0)");
-	return array($min,$max);
-    }	
+        $min=$aPlots[0]->Min();
+        $max=$aPlots[0]->Max();
+        foreach( $this->plots as $p ) {
+            $max=max($max,$p->Max());
+            $min=min($min,$p->Min());
+        }
+        if( $min < 0 ) {
+            JpGraphError::RaiseL(18006,$min);
+            //("Minimum data $min (Radar plots should only be used when all data points > 0)");
+        }
+        return array($min,$max);
+    }
+
+    function StrokeIcons() {
+    	if( $this->iIcons != null ) {
+        	$n = count($this->iIcons);
+        	for( $i=0; $i < $n; ++$i ) {
+            	$this->iIcons[$i]->Stroke($this->img);
+        	}
+    	}
+    }
+
+	function StrokeTexts() {
+        if( $this->texts != null ) {
+			$n = count($this->texts);
+            for( $i=0; $i < $n; ++$i ) {
+                $this->texts[$i]->Stroke($this->img);
+            }
+        }
+    }
 
     // Stroke the Radar graph
-    function Stroke($aStrokeFileName="") {
-	$n = count($this->plots);
-	// Set Y-scale
-	if( !$this->yscale->IsSpecified() && count($this->plots)>0 ) {
-	    list($min,$max) = $this->GetPlotsYMinMax($this->plots);
-	    $this->yscale->AutoScale($this->img,0,$max,$this->len/$this->ytick_factor);
-	}
-	elseif( $this->yscale->IsSpecified() && 
-		( $this->yscale->auto_ticks || !$this->yscale->ticks->IsSpecified()) ) {
-	    // The tick calculation will use the user suplied min/max values to determine
-	    // the ticks. If auto_ticks is false the exact user specifed min and max
-	    // values will be used for the scale. 
-	    // If auto_ticks is true then the scale might be slightly adjusted
-	    // so that the min and max values falls on an even major step.
-	    $min = $this->yscale->scale[0];
-	    $max = $this->yscale->scale[1];
-	    $this->yscale->AutoScale($this->img,$min,$max,
-				     $this->len/$this->ytick_factor,
-				     $this->yscale->auto_ticks);
-	}
-
-	// Set start position end length of scale (in absolute pixels)
-	$this->yscale->SetConstants($this->posx,$this->len);
-		
-	// We need as many axis as there are data points
-	$nbrpnts=$this->plots[0]->GetCount();
-		
-	// If we have no titles just number the axis 1,2,3,...
-	if( $this->axis_title==null ) {
-	    for($i=0; $i < $nbrpnts; ++$i ) 
-		$this->axis_title[$i] = $i+1;
-	}
-	elseif(count($this->axis_title)<$nbrpnts) 
-	    JpGraphError::RaiseL(18007);
-//("Number of titles does not match number of points in plot.");
-	for($i=0; $i < $n; ++$i )
-	    if( $nbrpnts != $this->plots[$i]->GetCount() )
-		JpGraphError::RaiseL(18008);
-//("Each radar plot must have the same number of data points.");
-
-	if( $this->background_image != "" ) {
-	    $this->StrokeFrameBackground();
-	}
-	else {	
-	    $this->StrokeFrame();
-	}
-	$astep=2*M_PI/$nbrpnts;
-
-	// Prepare legends
-	for($i=0; $i < $n; ++$i)
-	    $this->plots[$i]->Legend($this);
-	$this->legend->Stroke($this->img);			
-	$this->footer->Stroke($this->img);			
-
-	if( $this->grid_depth == DEPTH_BACK ) {
-	    // Draw axis and grid
-	    for( $i=0,$a=M_PI/2; $i < $nbrpnts; ++$i, $a += $astep ) {
-		$this->axis->Stroke($this->posy,$a,$grid[$i],$this->axis_title[$i],$i==0);
-	    }	
-	}
-		
-	// Plot points
-	$a=M_PI/2;
-	for($i=0; $i < $n; ++$i )
-	    $this->plots[$i]->Stroke($this->img, $this->posy, $this->yscale, $a);
-		
-	if( $this->grid_depth != DEPTH_BACK ) {
-	    // Draw axis and grid
-	    for( $i=0,$a=M_PI/2; $i < $nbrpnts; ++$i, $a += $astep ) {
-		$this->axis->Stroke($this->posy,$a,$grid[$i],$this->axis_title[$i],$i==0);
-	    }	
-	}
-	$this->grid->Stroke($this->img,$grid);
-	$this->StrokeTitles();
-	
-	// Stroke texts
-	if( $this->texts != null ) {
-	    foreach( $this->texts as $t) 
-		$t->Stroke($this->img);
-	}
-
-	// Should we do any final image transformation
-	if( $this->iImgTrans ) {
-	    if( !class_exists('ImgTrans',false) ) {
-		require_once('jpgraph_imgtrans.php');
-	    }
-	       
-	    $tform = new ImgTrans($this->img->img);
-	    $this->img->img = $tform->Skew3D($this->iImgTransHorizon,$this->iImgTransSkewDist,
-					     $this->iImgTransDirection,$this->iImgTransHighQ,
-					     $this->iImgTransMinSize,$this->iImgTransFillColor,
-					     $this->iImgTransBorder);
-	}
-	
-	// If the filename is given as the special "__handle"
-	// then the image handler is returned and the image is NOT
-	// streamed back
-	if( $aStrokeFileName == _IMG_HANDLER ) {
-	    return $this->img->img;
-	    }
-	else {
-	    // Finally stream the generated picture					
-	    $this->cache->PutAndStream($this->img,$this->cache_name,$this->inline,
-				       $aStrokeFileName);		
-	}
+    function Stroke($aStrokeFileName='') {
+
+        // If the filename is the predefined value = '_csim_special_'
+        // we assume that the call to stroke only needs to do enough
+        // to correctly generate the CSIM maps.
+        // We use this variable to skip things we don't strictly need
+        // to do to generate the image map to improve performance
+        // a best we can. Therefor you will see a lot of tests !$_csim in the
+        // code below.
+        $_csim = ( $aStrokeFileName === _CSIM_SPECIALFILE );
+
+        // We need to know if we have stroked the plot in the
+        // GetCSIMareas. Otherwise the CSIM hasn't been generated
+        // and in the case of GetCSIM called before stroke to generate
+        // CSIM without storing an image to disk GetCSIM must call Stroke.
+        $this->iHasStroked = true;
+
+        $n = count($this->plots);
+        // Set Y-scale
+
+        if( !$this->yscale->IsSpecified() && count($this->plots) > 0 ) {
+            list($min,$max) = $this->GetPlotsYMinMax($this->plots);
+            $this->yscale->AutoScale($this->img,0,$max,$this->len/$this->ytick_factor);
+        }
+        elseif( $this->yscale->IsSpecified() &&
+                ( $this->yscale->auto_ticks || !$this->yscale->ticks->IsSpecified()) ) {
+
+            // The tick calculation will use the user suplied min/max values to determine
+            // the ticks. If auto_ticks is false the exact user specifed min and max
+            // values will be used for the scale.
+            // If auto_ticks is true then the scale might be slightly adjusted
+            // so that the min and max values falls on an even major step.
+            $min = $this->yscale->scale[0];
+            $max = $this->yscale->scale[1];
+            $this->yscale->AutoScale($this->img,$min,$max,
+                                     $this->len/$this->ytick_factor,
+                                     $this->yscale->auto_ticks);
+        }
+
+        // Set start position end length of scale (in absolute pixels)
+        $this->yscale->SetConstants($this->posx,$this->len);
+
+        // We need as many axis as there are data points
+        $nbrpnts=$this->plots[0]->GetCount();
+
+        // If we have no titles just number the axis 1,2,3,...
+        if( $this->axis_title==null ) {
+            for($i=0; $i < $nbrpnts; ++$i ) {
+                $this->axis_title[$i] = $i+1;
+            }
+        }
+        elseif( count($this->axis_title) < $nbrpnts) {
+            JpGraphError::RaiseL(18007);
+            // ("Number of titles does not match number of points in plot.");
+        }
+        for( $i=0; $i < $n; ++$i ) {
+            if( $nbrpnts != $this->plots[$i]->GetCount() ) {
+                JpGraphError::RaiseL(18008);
+                //("Each radar plot must have the same number of data points.");
+            }
+        }
+
+        if( !$_csim ) {
+        	if( $this->background_image != '' ) {
+            	$this->StrokeFrameBackground();
+        	}
+        	else {
+            	$this->StrokeFrame();
+            	$this->StrokeBackgroundGrad();
+        	}
+        }
+        $astep=2*M_PI/$nbrpnts;
+
+		if( !$_csim ) {
+     		if( $this->iIconDepth == DEPTH_BACK ) {
+        		$this->StrokeIcons();
+        	}
+
+
+	        // Prepare legends
+    	    for($i=0; $i < $n; ++$i) {
+        	    $this->plots[$i]->Legend($this);
+	        }
+    	    $this->legend->Stroke($this->img);
+        	$this->footer->Stroke($this->img);
+		}
+
+		if( !$_csim ) {
+	        if( $this->grid_depth == DEPTH_BACK ) {
+	            // Draw axis and grid
+	            for( $i=0,$a=M_PI/2; $i < $nbrpnts; ++$i, $a += $astep ) {
+	                $this->axis->Stroke($this->posy,$a,$grid[$i],$this->axis_title[$i],$i==0);
+	            }
+                $this->grid->Stroke($this->img,$grid);
+	        }
+            if( $this->iIconDepth == DEPTH_BACK ) {
+                $this->StrokeIcons();
+            }
+
+		}
+
+        // Plot points
+        $a=M_PI/2;
+        for($i=0; $i < $n; ++$i ) {
+            $this->plots[$i]->Stroke($this->img, $this->posy, $this->yscale, $a);
+        }
+
+        if( !$_csim ) {
+            if( $this->grid_depth != DEPTH_BACK ) {
+                // Draw axis and grid
+                for( $i=0,$a=M_PI/2; $i < $nbrpnts; ++$i, $a += $astep ) {
+                   $this->axis->Stroke($this->posy,$a,$grid[$i],$this->axis_title[$i],$i==0);
+                }
+                $this->grid->Stroke($this->img,$grid);
+            }
+
+        	$this->StrokeTitles();
+       		$this->StrokeTexts();
+       		if( $this->iIconDepth == DEPTH_FRONT ) {
+        		$this->StrokeIcons();
+        	}
+		}
+
+        // Should we do any final image transformation
+        if( $this->iImgTrans && !$_csim ) {
+            if( !class_exists('ImgTrans',false) ) {
+                require_once('jpgraph_imgtrans.php');
+            }
+
+            $tform = new ImgTrans($this->img->img);
+            $this->img->img = $tform->Skew3D($this->iImgTransHorizon,$this->iImgTransSkewDist,
+            $this->iImgTransDirection,$this->iImgTransHighQ,
+            $this->iImgTransMinSize,$this->iImgTransFillColor,
+            $this->iImgTransBorder);
+        }
+
+		if( !$_csim ) {
+	        // If the filename is given as the special "__handle"
+	        // then the image handler is returned and the image is NOT
+	        // streamed back
+	        if( $aStrokeFileName == _IMG_HANDLER ) {
+	            return $this->img->img;
+	        }
+	        else {
+	            // Finally stream the generated picture
+	            $this->cache->PutAndStream($this->img,$this->cache_name,$this->inline,$aStrokeFileName);
+	        }
+		}
     }
 } // Class
Index: trunk/client/modules/Elezioni/grafici/jpgraph_regstat.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph_regstat.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph_regstat.php	(revision 265)
@@ -1,12 +1,12 @@
-<?php 
+<?php
 /*=======================================================================
-// File:	JPGRAPH_REGSTAT.PHP
-// Description: Regression and statistical analysis helper classes
-// Created: 	2002-12-01
-// Ver:		$Id: jpgraph_regstat.php 781 2006-10-08 08:07:47Z ljp $
-//
-// Copyright (c) Aditus Consulting. All rights reserved.
-//========================================================================
-*/
+ // File:        JPGRAPH_REGSTAT.PHP
+ // Description: Regression and statistical analysis helper classes
+ // Created:     2002-12-01
+ // Ver:         $Id: jpgraph_regstat.php 1131 2009-03-11 20:08:24Z ljp $
+ //
+ // Copyright (c) Asial Corporation. All rights reserved.
+ //========================================================================
+ */
 
 //------------------------------------------------------------------------
@@ -19,58 +19,58 @@
 
     private $xdata,$ydata;   // Data vectors
-    private $y2;		 // 2:nd derivate of ydata	
+    private $y2;   // 2:nd derivate of ydata
     private $n=0;
 
-    function Spline($xdata,$ydata) {
-	$this->y2 = array();
-	$this->xdata = $xdata;
-	$this->ydata = $ydata;
-
-	$n = count($ydata);
-	$this->n = $n;
-	if( $this->n !== count($xdata) ) {
-	    JpGraphError::RaiseL(19001);
-//('Spline: Number of X and Y coordinates must be the same');
-	}
-
-	// Natural spline 2:derivate == 0 at endpoints
-	$this->y2[0]    = 0.0;
-	$this->y2[$n-1] = 0.0;
-	$delta[0] = 0.0;
-
-	// Calculate 2:nd derivate
-	for($i=1; $i < $n-1; ++$i) {
-	    $d = ($xdata[$i+1]-$xdata[$i-1]);
-	    if( $d == 0  ) {
-		JpGraphError::RaiseL(19002);
-//('Invalid input data for spline. Two or more consecutive input X-values are equal. Each input X-value must differ since from a mathematical point of view it must be a one-to-one mapping, i.e. each X-value must correspond to exactly one Y-value.');
-	    }
-	    $s = ($xdata[$i]-$xdata[$i-1])/$d;
-	    $p = $s*$this->y2[$i-1]+2.0;
-	    $this->y2[$i] = ($s-1.0)/$p;
-	    $delta[$i] = ($ydata[$i+1]-$ydata[$i])/($xdata[$i+1]-$xdata[$i]) - 
-		         ($ydata[$i]-$ydata[$i-1])/($xdata[$i]-$xdata[$i-1]);
-	    $delta[$i] = (6.0*$delta[$i]/($xdata[$i+1]-$xdata[$i-1])-$s*$delta[$i-1])/$p;
-	}
-
-	// Backward substitution
-	for( $j=$n-2; $j >= 0; --$j ) {
-	    $this->y2[$j] = $this->y2[$j]*$this->y2[$j+1] + $delta[$j];
-	}
+    function __construct($xdata,$ydata) {
+        $this->y2 = array();
+        $this->xdata = $xdata;
+        $this->ydata = $ydata;
+
+        $n = count($ydata);
+        $this->n = $n;
+        if( $this->n !== count($xdata) ) {
+            JpGraphError::RaiseL(19001);
+            //('Spline: Number of X and Y coordinates must be the same');
+        }
+
+        // Natural spline 2:derivate == 0 at endpoints
+        $this->y2[0]    = 0.0;
+        $this->y2[$n-1] = 0.0;
+        $delta[0] = 0.0;
+
+        // Calculate 2:nd derivate
+        for($i=1; $i < $n-1; ++$i) {
+            $d = ($xdata[$i+1]-$xdata[$i-1]);
+            if( $d == 0  ) {
+                JpGraphError::RaiseL(19002);
+                //('Invalid input data for spline. Two or more consecutive input X-values are equal. Each input X-value must differ since from a mathematical point of view it must be a one-to-one mapping, i.e. each X-value must correspond to exactly one Y-value.');
+            }
+            $s = ($xdata[$i]-$xdata[$i-1])/$d;
+            $p = $s*$this->y2[$i-1]+2.0;
+            $this->y2[$i] = ($s-1.0)/$p;
+            $delta[$i] = ($ydata[$i+1]-$ydata[$i])/($xdata[$i+1]-$xdata[$i]) -
+            ($ydata[$i]-$ydata[$i-1])/($xdata[$i]-$xdata[$i-1]);
+            $delta[$i] = (6.0*$delta[$i]/($xdata[$i+1]-$xdata[$i-1])-$s*$delta[$i-1])/$p;
+        }
+
+        // Backward substitution
+        for( $j=$n-2; $j >= 0; --$j ) {
+            $this->y2[$j] = $this->y2[$j]*$this->y2[$j+1] + $delta[$j];
+        }
     }
 
     // Return the two new data vectors
     function Get($num=50) {
-	$n = $this->n ;
-	$step = ($this->xdata[$n-1]-$this->xdata[0]) / ($num-1);
-	$xnew=array();
-	$ynew=array();
-	$xnew[0] = $this->xdata[0];
-	$ynew[0] = $this->ydata[0];
-	for( $j=1; $j < $num; ++$j ) {
-	    $xnew[$j] = $xnew[0]+$j*$step;
-	    $ynew[$j] = $this->Interpolate($xnew[$j]);
-	}
-	return array($xnew,$ynew);
+        $n = $this->n ;
+        $step = ($this->xdata[$n-1]-$this->xdata[0]) / ($num-1);
+        $xnew=array();
+        $ynew=array();
+        $xnew[0] = $this->xdata[0];
+        $ynew[0] = $this->ydata[0];
+        for( $j=1; $j < $num; ++$j ) {
+            $xnew[$j] = $xnew[0]+$j*$step;
+            $ynew[$j] = $this->Interpolate($xnew[$j]);
+        }
+        return array($xnew,$ynew);
     }
 
@@ -78,29 +78,29 @@
     function Interpolate($xpoint) {
 
-	$max = $this->n-1;
-	$min = 0;
-
-	// Binary search to find interval
-	while( $max-$min > 1 ) {
-	    $k = ($max+$min) / 2;
-	    if( $this->xdata[$k] > $xpoint ) 
-		$max=$k;
-	    else 
-		$min=$k;
-	}	
-
-	// Each interval is interpolated by a 3:degree polynom function
-	$h = $this->xdata[$max]-$this->xdata[$min];
-
-	if( $h == 0  ) {
-	    JpGraphError::RaiseL(19002);
-//('Invalid input data for spline. Two or more consecutive input X-values are equal. Each input X-value must differ since from a mathematical point of view it must be a one-to-one mapping, i.e. each X-value must correspond to exactly one Y-value.');
-	}
-
-
-	$a = ($this->xdata[$max]-$xpoint)/$h;
-	$b = ($xpoint-$this->xdata[$min])/$h;
-	return $a*$this->ydata[$min]+$b*$this->ydata[$max]+
-	     (($a*$a*$a-$a)*$this->y2[$min]+($b*$b*$b-$b)*$this->y2[$max])*($h*$h)/6.0;
+        $max = $this->n-1;
+        $min = 0;
+
+        // Binary search to find interval
+        while( $max-$min > 1 ) {
+            $k = ($max+$min) / 2;
+            if( $this->xdata[$k] > $xpoint )
+            $max=$k;
+            else
+            $min=$k;
+        }
+
+        // Each interval is interpolated by a 3:degree polynom function
+        $h = $this->xdata[$max]-$this->xdata[$min];
+
+        if( $h == 0  ) {
+            JpGraphError::RaiseL(19002);
+            //('Invalid input data for spline. Two or more consecutive input X-values are equal. Each input X-value must differ since from a mathematical point of view it must be a one-to-one mapping, i.e. each X-value must correspond to exactly one Y-value.');
+        }
+
+
+        $a = ($this->xdata[$max]-$xpoint)/$h;
+        $b = ($xpoint-$this->xdata[$min])/$h;
+        return $a*$this->ydata[$min]+$b*$this->ydata[$max]+
+        (($a*$a*$a-$a)*$this->y2[$min]+($b*$b*$b-$b)*$this->y2[$max])*($h*$h)/6.0;
     }
 }
@@ -111,89 +111,102 @@
 //------------------------------------------------------------------------
 class Bezier {
-/**
- * @author Thomas Despoix, openXtrem company
- * @license released under QPL
- * @abstract Bezier interoplated point generation,
- * computed from control points data sets, based on Paul Bourke algorithm :
- * http://astronomy.swin.edu.au/~pbourke/curves/bezier/
- */
+    /**
+     * @author Thomas Despoix, openXtrem company
+     * @license released under QPL
+     * @abstract Bezier interoplated point generation,
+     * computed from control points data sets, based on Paul Bourke algorithm :
+     * http://local.wasp.uwa.edu.au/~pbourke/geometry/bezier/index2.html
+     */
     private $datax = array();
     private $datay = array();
     private $n=0;
- 
-    function Bezier($datax, $datay, $attraction_factor = 1) {
-	// Adding control point multiple time will raise their attraction power over the curve
-	$this->n = count($datax);
-	if( $this->n !== count($datay) ) {
-	    JpGraphError::RaiseL(19003);
-//('Bezier: Number of X and Y coordinates must be the same');
-	}
-	$idx=0;
-	foreach($datax as $datumx) {
-	    for ($i = 0; $i < $attraction_factor; $i++) {
-		$this->datax[$idx++] = $datumx;
-	    }
-	}
-   	$idx=0;
-	foreach($datay as $datumy) {
-	    for ($i = 0; $i < $attraction_factor; $i++) {
-		$this->datay[$idx++] = $datumy;
-	    }
-	}
-	$this->n *= $attraction_factor;
-    }
-
+
+    function __construct($datax, $datay, $attraction_factor = 1) {
+        // Adding control point multiple time will raise their attraction power over the curve
+        $this->n = count($datax);
+        if( $this->n !== count($datay) ) {
+            JpGraphError::RaiseL(19003);
+            //('Bezier: Number of X and Y coordinates must be the same');
+        }
+        $idx=0;
+        foreach($datax as $datumx) {
+            for ($i = 0; $i < $attraction_factor; $i++) {
+                $this->datax[$idx++] = $datumx;
+            }
+        }
+        $idx=0;
+        foreach($datay as $datumy) {
+            for ($i = 0; $i < $attraction_factor; $i++) {
+                $this->datay[$idx++] = $datumy;
+            }
+        }
+        $this->n *= $attraction_factor;
+    }
+
+    /**
+     * Return a set of data points that specifies the bezier curve with $steps points
+     * @param $steps Number of new points to return
+     * @return array($datax, $datay)
+     */
     function Get($steps) {
-	$datax = array();
-	$datay = array();
-	for ($i = 0; $i < $steps; $i++) {
-	    list($datumx, $datumy) = $this->GetPoint((double) $i / (double) $steps);       
-	    $datax[] = $datumx;
-	    $datay[] = $datumy;
-	}
-   
-	$datax[] = end($this->datax);
-	$datay[] = end($this->datay);
-   
-	return array($datax, $datay);
-    }
- 
+        $datax = array();
+        $datay = array();
+        for ($i = 0; $i < $steps; $i++) {
+            list($datumx, $datumy) = $this->GetPoint((double) $i / (double) $steps);
+            $datax[$i] = $datumx;
+            $datay[$i] = $datumy;
+        }
+         
+        $datax[] = end($this->datax);
+        $datay[] = end($this->datay);
+         
+        return array($datax, $datay);
+    }
+
+    /**
+     * Return one point on the bezier curve. $mu is the position on the curve where $mu is in the
+     * range 0 $mu < 1 where 0 is tha start point and 1 is the end point. Note that every newly computed
+     * point depends on all the existing points
+     * 
+     * @param $mu Position on the bezier curve
+     * @return array($x, $y)
+     */
     function GetPoint($mu) {
-	$n = $this->n - 1;
-	$k = 0;
-	$kn = 0;
-	$nn = 0;
-	$nkn = 0;
-	$blend = 0.0;
-	$newx = 0.0;
-	$newy = 0.0;
-
-	$muk = 1.0;
-	$munk = (double) pow(1-$mu,(double) $n);
-
-	for ($k = 0; $k <= $n; $k++) {
-	    $nn = $n;
-	    $kn = $k;
-	    $nkn = $n - $k;
-	    $blend = $muk * $munk;
-	    $muk *= $mu;
-	    $munk /= (1-$mu);
-	    while ($nn >= 1) {
-		$blend *= $nn;
-		$nn--;
-		if ($kn > 1) {
-		    $blend /= (double) $kn;
-		    $kn--;
-		}
-		if ($nkn > 1) {
-		    $blend /= (double) $nkn;
-		    $nkn--;
-		}
-	    }
-	    $newx += $this->datax[$k] * $blend;
-	    $newy += $this->datay[$k] * $blend;
-	}
-
-	return array($newx, $newy);
+        $n = $this->n - 1;
+        $k = 0;
+        $kn = 0;
+        $nn = 0;
+        $nkn = 0;
+        $blend = 0.0;
+        $newx = 0.0;
+        $newy = 0.0;
+
+        $muk = 1.0;
+        $munk = (double) pow(1-$mu,(double) $n);
+
+        for ($k = 0; $k <= $n; $k++) {
+            $nn = $n;
+            $kn = $k;
+            $nkn = $n - $k;
+            $blend = $muk * $munk;
+            $muk *= $mu;
+            $munk /= (1-$mu);
+            while ($nn >= 1) {
+                $blend *= $nn;
+                $nn--;
+                if ($kn > 1) {
+                    $blend /= (double) $kn;
+                    $kn--;
+                }
+                if ($nkn > 1) {
+                    $blend /= (double) $nkn;
+                    $nkn--;
+                }
+            }
+            $newx += $this->datax[$k] * $blend;
+            $newy += $this->datay[$k] * $blend;
+        }
+
+        return array($newx, $newy);
     }
 }
